Index: /trunk/src/sys/arch/sgimips/gio/newport.c
===================================================================
--- /trunk/src/sys/arch/sgimips/gio/newport.c	(revision 151)
+++ /trunk/src/sys/arch/sgimips/gio/newport.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: newport.c,v 1.10 2007/03/04 06:00:39 christos Exp $	*/
+/*	$NetBSD: newport.c,v 1.10.62.1 2010/12/29 07:19:28 matt Exp $	*/
 
 /*
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: newport.c,v 1.10 2007/03/04 06:00:39 christos Exp $");
+__KERNEL_RCSID(0, "$NetBSD: newport.c,v 1.10.62.1 2010/12/29 07:19:28 matt Exp $");
 
 #include <sys/param.h>
@@ -43,4 +43,6 @@
 #include <dev/wscons/wsdisplayvar.h>
 #include <dev/wsfont/wsfont.h>
+#include <dev/rasops/rasops.h>
+#include <dev/wscons/wsdisplay_vconsvar.h>
 
 #include <sgimips/gio/giovar.h>
@@ -49,7 +51,8 @@
 
 struct newport_softc {
-	struct device sc_dev;
+	device_t sc_dev;
 
 	struct newport_devconfig *sc_dc;
+	
 };
 
@@ -70,15 +73,19 @@
 
 	int			dc_font;
+	struct wsscreen_descr	*dc_screen;
 	struct wsdisplay_font	*dc_fontdata;
+	int			dc_mode;
+	struct vcons_data	dc_vd;
 };
 
-static int  newport_match(struct device *, struct cfdata *, void *);
-static void newport_attach(struct device *, struct device *, void *);
-
-CFATTACH_DECL(newport, sizeof(struct newport_softc),
+static int  newport_match(device_t, struct cfdata *, void *);
+static void newport_attach(device_t, device_t, void *);
+
+CFATTACH_DECL_NEW(newport, sizeof(struct newport_softc),
     newport_match, newport_attach, NULL, NULL);
 
 /* textops */
 static void newport_cursor(void *, int, int, int);
+static void newport_cursor_dummy(void *, int, int, int);
 static int  newport_mapchar(void *, int, unsigned int *);
 static void newport_putchar(void *, int, int, u_int, long);
@@ -89,16 +96,18 @@
 static int  newport_allocattr(void *, int, int, int, long *);
 
+static void newport_init_screen(void *, struct vcons_screen *, int, long *);
+
 /* accessops */
 static int     newport_ioctl(void *, void *, u_long, void *, int,
     struct lwp *);
 static paddr_t newport_mmap(void *, void *, off_t, int);
-static int     newport_alloc_screen(void *, const struct wsscreen_descr *,
-    void **, int *, int *, long *);
-static void    newport_free_screen(void *, void *);
-static int     newport_show_screen(void *, void *, int,
-    void (*)(void *, int, int), void *);
-
-static const struct wsdisplay_emulops newport_textops = {
-	.cursor		= newport_cursor,
+
+static struct wsdisplay_accessops newport_accessops = {
+	.ioctl		= newport_ioctl,
+	.mmap		= newport_mmap,
+};
+
+static struct wsdisplay_emulops newport_textops = {
+	.cursor		= newport_cursor_dummy,
 	.mapchar	= newport_mapchar,
 	.putchar	= newport_putchar,
@@ -110,24 +119,6 @@
 };
 
-static const struct wsdisplay_accessops newport_accessops = {
-	.ioctl		= newport_ioctl,
-	.mmap		= newport_mmap,
-	.alloc_screen	= newport_alloc_screen,
-	.free_screen	= newport_free_screen,
-	.show_screen	= newport_show_screen,
-};
-
-static const struct wsscreen_descr newport_screen_1024x768 = {
-	.name		= "1024x768",
-	.ncols		= 128,
-	.nrows		= 48,
-	.textops	= &newport_textops,
-	.fontwidth	= 8,
-	.fontheight	= 16,
-	.capabilities	= WSSCREEN_WSCOLORS | WSSCREEN_HILIT | WSSCREEN_REVERSE
-};
-
-static const struct wsscreen_descr newport_screen_1280x1024 = {
-	.name		= "1280x1024",
+static struct wsscreen_descr newport_screen = {
+	.name		= "default",
 	.ncols		= 160,
 	.nrows		= 64,
@@ -139,6 +130,5 @@
 
 static const struct wsscreen_descr *_newport_screenlist[] = {
-	&newport_screen_1024x768,
-	&newport_screen_1280x1024
+	&newport_screen
 };
 
@@ -148,4 +138,5 @@
 };
 
+static struct vcons_screen newport_console_screen;
 static struct newport_devconfig newport_console_dc;
 static int newport_is_console = 0;
@@ -155,95 +146,5 @@
 #define NEWPORT_ATTR_FG(a)		(((a) >> 8) & 0xff)
 
-static const uint16_t newport_cursor_data[128] = {
-	/* Bit 0 */
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0xff00, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-
-	/* Bit 1 */
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-	0x0000, 0x0000,
-};
-
-static const uint8_t newport_defcmap[16*3] = {
-	/* Normal colors */
-	0x00, 0x00, 0x00, /* black */
-	0x7f, 0x00, 0x00, /* red */
-	0x00, 0x7f, 0x00, /* green */
-	0x7f, 0x7f, 0x00, /* brown */
-	0x00, 0x00, 0x7f, /* blue */
-	0x7f, 0x00, 0x7f, /* magenta */
-	0x00, 0x7f, 0x7f, /* cyan */
-	0xc7, 0xc7, 0xc7, /* white - XXX too dim? */
-
-	/* Hilite colors */
-	0x7f, 0x7f, 0x7f, /* black */
-	0xff, 0x00, 0x00, /* red */
-	0x00, 0xff, 0x00, /* green */
-	0xff, 0xff, 0x00, /* brown */
-	0x00, 0x00, 0xff, /* blue */
-	0xff, 0x00, 0xff, /* magenta */
-	0x00, 0xff, 0xff, /* cyan */
-	0xff, 0xff, 0xff, /* white */
-};
+extern const u_char rasops_cmap[768];
 
 /**** Low-level hardware register groveling functions ****/
@@ -328,4 +229,5 @@
 }
 
+#if 0
 static void
 vc2_write_ram(struct newport_devconfig *dc, uint16_t addr, uint16_t val)
@@ -342,4 +244,5 @@
 	rex3_write(dc, REX3_REG_DCBDATA0, val << 16);
 }
+#endif
 
 static u_int32_t
@@ -394,155 +297,4 @@
 	    REX3_DRAWMODE0_ADRMODE_BLOCK | REX3_DRAWMODE0_DOSETUP |
 	    REX3_DRAWMODE0_STOPONX | REX3_DRAWMODE0_STOPONY);
-	rex3_write(dc, REX3_REG_WRMASK, 0xffffffff);
-	rex3_write(dc, REX3_REG_COLORI, color);
-	rex3_write(dc, REX3_REG_XYSTARTI, (x1 << REX3_XYSTARTI_XSHIFT) | y1);
-
-	rex3_write_go(dc, REX3_REG_XYENDI, (x2 << REX3_XYENDI_XSHIFT) | y2);
-}
-
-static void
-newport_copy_rectangle(struct newport_devconfig *dc, int x1, int y1, int x2,
-    int y2, int dx, int dy)
-{
-	uint32_t tmp;
-
-	rex3_wait_gfifo(dc);
-	
-	rex3_write(dc, REX3_REG_DRAWMODE0, REX3_DRAWMODE0_OPCODE_SCR2SCR |
-	    REX3_DRAWMODE0_ADRMODE_BLOCK | REX3_DRAWMODE0_DOSETUP |
-	    REX3_DRAWMODE0_STOPONX | REX3_DRAWMODE0_STOPONY);
-	rex3_write(dc, REX3_REG_XYSTARTI, (x1 << REX3_XYSTARTI_XSHIFT) | y1);
-	rex3_write(dc, REX3_REG_XYENDI, (x2 << REX3_XYENDI_XSHIFT) | y2);
-
-	tmp = (dy - y1) & 0xffff;
-	tmp |= (dx - x1) << REX3_XYMOVE_XSHIFT;
-
-	rex3_write_go(dc, REX3_REG_XYMOVE, tmp);
-}
-
-static void
-newport_cmap_setrgb(struct newport_devconfig *dc, int index, uint8_t r,
-    uint8_t g, uint8_t b)
-{
-	rex3_write(dc, REX3_REG_DCBMODE,
-	    REX3_DCBMODE_DW_2 |
-	    REX3_DCBMODE_ENCRSINC |
-	    (NEWPORT_DCBADDR_CMAP_BOTH << REX3_DCBMODE_DCBADDR_SHIFT) |
-	    (CMAP_DCBCRS_ADDRESS_LOW << REX3_DCBMODE_DCBCRS_SHIFT) |
-	    (1 << REX3_DCBMODE_CSWIDTH_SHIFT) |
-	    (1 << REX3_DCBMODE_CSHOLD_SHIFT) |
-	    (1 << REX3_DCBMODE_CSSETUP_SHIFT) |
-	    REX3_DCBMODE_SWAPENDIAN);
-
-	rex3_write(dc, REX3_REG_DCBDATA0, index << 16);
-
-	rex3_write(dc, REX3_REG_DCBMODE,
-	    REX3_DCBMODE_DW_3 |
-	    (NEWPORT_DCBADDR_CMAP_BOTH << REX3_DCBMODE_DCBADDR_SHIFT) |
-	    (CMAP_DCBCRS_PALETTE << REX3_DCBMODE_DCBCRS_SHIFT) |
-	    (1 << REX3_DCBMODE_CSWIDTH_SHIFT) |
-	    (1 << REX3_DCBMODE_CSHOLD_SHIFT) |
-	    (1 << REX3_DCBMODE_CSSETUP_SHIFT));
-
-	rex3_write(dc, REX3_REG_DCBDATA0, (r << 24) + (g << 16) + (b << 8));
-}
-
-static void
-newport_get_resolution(struct newport_devconfig *dc)
-{
-	uint16_t vep,lines;
-	uint16_t linep,cols;
-	uint16_t data;
-
-	vep = vc2_read_ireg(dc, VC2_IREG_VIDEO_ENTRY);
-
-	dc->dc_xres = 0;
-	dc->dc_yres = 0;
-
-	for (;;) {
-		/* Iterate over runs in video timing table */
-
-		cols = 0;
-
-		linep = vc2_read_ram(dc, vep++);
-		lines = vc2_read_ram(dc, vep++);
-
-		if (lines == 0)
-			break;
-
-		do {
-			/* Iterate over state runs in line sequence table */
-		
-			data = vc2_read_ram(dc, linep++);
-
-			if ((data & 0x0001) == 0)
-				cols += (data >> 7) & 0xfe;
-
-			if ((data & 0x0080) == 0)
-				data = vc2_read_ram(dc, linep++);
-		} while ((data & 0x8000) == 0);
-
-		if (cols != 0) {
-			if (cols > dc->dc_xres)
-				dc->dc_xres = cols;
-
-			dc->dc_yres += lines;
-		}
-	}
-}
-
-static void
-newport_setup_hw(struct newport_devconfig *dc)
-{
-	uint16_t curp,tmp;
-	int i;
-	uint32_t scratch;
-
-	/* Get various revisions */
-	rex3_write(dc, REX3_REG_DCBMODE,
-	    REX3_DCBMODE_DW_1 |
-	    (NEWPORT_DCBADDR_CMAP_0 << REX3_DCBMODE_DCBADDR_SHIFT) |
-	    (CMAP_DCBCRS_REVISION << REX3_DCBMODE_DCBCRS_SHIFT) |
-	    (1 << REX3_DCBMODE_CSWIDTH_SHIFT) |
-	    (1 << REX3_DCBMODE_CSHOLD_SHIFT) |
-	    (1 << REX3_DCBMODE_CSSETUP_SHIFT));
-
-	scratch = vc2_read_ireg(dc, VC2_IREG_CONFIG);
-	dc->dc_vc2rev = (scratch & VC2_IREG_CONFIG_REVISION) >> 5;
-
-	scratch = rex3_read(dc, REX3_REG_DCBDATA0);
-
-	dc->dc_boardrev = (scratch >> 28) & 0x07;
-	dc->dc_cmaprev = scratch & 0x07;
-	dc->dc_xmaprev = xmap9_read(dc, XMAP9_DCBCRS_REVISION) & 0x07;
-	dc->dc_depth = ( (dc->dc_boardrev > 1) && (scratch & 0x80)) ? 8 : 24;
-
-	/* Setup cursor glyph */
-	curp = vc2_read_ireg(dc, VC2_IREG_CURSOR_ENTRY);
-
-	for (i=0; i<128; i++)
-		vc2_write_ram(dc, curp + i, newport_cursor_data[i]);
-
-	/* Setup VC2 to a known state */
-	tmp = vc2_read_ireg(dc, VC2_IREG_CONTROL) & VC2_CONTROL_INTERLACE;
-	vc2_write_ireg(dc, VC2_IREG_CONTROL, tmp |
-	    VC2_CONTROL_DISPLAY_ENABLE |
-	    VC2_CONTROL_VTIMING_ENABLE |
-	    VC2_CONTROL_DID_ENABLE |
-	    VC2_CONTROL_CURSORFUNC_ENABLE |
-	    VC2_CONTROL_CURSOR_ENABLE);
-
-	/* Setup XMAP9s */
-	xmap9_write(dc, XMAP9_DCBCRS_CONFIG,
-	    XMAP9_CONFIG_8BIT_SYSTEM | XMAP9_CONFIG_RGBMAP_CI);
-
-	xmap9_write(dc, XMAP9_DCBCRS_CURSOR_CMAP, 0);
-
-	xmap9_write_mode(dc, 0,
-	    XMAP9_MODE_GAMMA_BYPASS |
-	    XMAP9_MODE_PIXSIZE_8BPP);
-	xmap9_write(dc, XMAP9_DCBCRS_MODE_SELECT, 0);
-
-	/* Setup REX3 */
 	rex3_write(dc, REX3_REG_DRAWMODE1,
 	    REX3_DRAWMODE1_PLANES_CI |
@@ -554,16 +306,189 @@
 	    REX3_DRAWMODE1_COMPARE_GT |
 	    REX3_DRAWMODE1_LO_SRC);
+	rex3_write(dc, REX3_REG_WRMASK, 0xffffffff);
+	rex3_write(dc, REX3_REG_COLORI, color);
+	rex3_write(dc, REX3_REG_XYSTARTI, (x1 << REX3_XYSTARTI_XSHIFT) | y1);
+
+	rex3_write_go(dc, REX3_REG_XYENDI, (x2 << REX3_XYENDI_XSHIFT) | y2);
+}
+
+static void
+newport_bitblt(struct newport_devconfig *dc, int xs, int ys, int xd,
+    int yd, int wi, int he, int rop)
+{
+	int xe, ye;
+	uint32_t tmp;
+
+	rex3_wait_gfifo(dc);
+	if (yd > ys) {
+		/* need to copy bottom up */
+		ye = ys;
+		yd += he - 1;
+		ys += he - 1;
+	} else
+		ye = ys + he - 1;
+
+	if (xd > xs) {
+		/* need to copy right to left */
+		xe = xs;
+		xd += wi - 1;
+		xs += wi - 1;
+	} else
+		xe = xs + wi - 1;
+
+	rex3_write(dc, REX3_REG_DRAWMODE0, REX3_DRAWMODE0_OPCODE_SCR2SCR |
+	    REX3_DRAWMODE0_ADRMODE_BLOCK | REX3_DRAWMODE0_DOSETUP |
+	    REX3_DRAWMODE0_STOPONX | REX3_DRAWMODE0_STOPONY);
+	rex3_write(dc, REX3_REG_DRAWMODE1,
+	    REX3_DRAWMODE1_PLANES_CI |
+	    REX3_DRAWMODE1_DD_DD8 |
+	    REX3_DRAWMODE1_RWPACKED |
+	    REX3_DRAWMODE1_HD_HD8 |
+	    REX3_DRAWMODE1_COMPARE_LT |
+	    REX3_DRAWMODE1_COMPARE_EQ |
+	    REX3_DRAWMODE1_COMPARE_GT |
+	    ((rop << 28) & REX3_DRAWMODE1_LOGICOP_MASK));
+	rex3_write(dc, REX3_REG_XYSTARTI, (xs << REX3_XYSTARTI_XSHIFT) | ys);
+	rex3_write(dc, REX3_REG_XYENDI, (xe << REX3_XYENDI_XSHIFT) | ye);
+
+	tmp = (yd - ys) & 0xffff;
+	tmp |= (xd - xs) << REX3_XYMOVE_XSHIFT;
+
+	rex3_write_go(dc, REX3_REG_XYMOVE, tmp);
+}
+
+static void
+newport_cmap_setrgb(struct newport_devconfig *dc, int index, uint8_t r,
+    uint8_t g, uint8_t b)
+{
+	rex3_write(dc, REX3_REG_DCBMODE,
+	    REX3_DCBMODE_DW_2 |
+	    REX3_DCBMODE_ENCRSINC |
+	    (NEWPORT_DCBADDR_CMAP_BOTH << REX3_DCBMODE_DCBADDR_SHIFT) |
+	    (CMAP_DCBCRS_ADDRESS_LOW << REX3_DCBMODE_DCBCRS_SHIFT) |
+	    (1 << REX3_DCBMODE_CSWIDTH_SHIFT) |
+	    (1 << REX3_DCBMODE_CSHOLD_SHIFT) |
+	    (1 << REX3_DCBMODE_CSSETUP_SHIFT) |
+	    REX3_DCBMODE_SWAPENDIAN);
+
+	rex3_write(dc, REX3_REG_DCBDATA0, index << 16);
+
+	rex3_write(dc, REX3_REG_DCBMODE,
+	    REX3_DCBMODE_DW_3 |
+	    (NEWPORT_DCBADDR_CMAP_BOTH << REX3_DCBMODE_DCBADDR_SHIFT) |
+	    (CMAP_DCBCRS_PALETTE << REX3_DCBMODE_DCBCRS_SHIFT) |
+	    (1 << REX3_DCBMODE_CSWIDTH_SHIFT) |
+	    (1 << REX3_DCBMODE_CSHOLD_SHIFT) |
+	    (1 << REX3_DCBMODE_CSSETUP_SHIFT));
+
+	rex3_write(dc, REX3_REG_DCBDATA0, (r << 24) + (g << 16) + (b << 8));
+}
+
+static void
+newport_get_resolution(struct newport_devconfig *dc)
+{
+	uint16_t vep,lines;
+	uint16_t linep,cols;
+	uint16_t data;
+
+	vep = vc2_read_ireg(dc, VC2_IREG_VIDEO_ENTRY);
+
+	dc->dc_xres = 0;
+	dc->dc_yres = 0;
+
+	for (;;) {
+		/* Iterate over runs in video timing table */
+
+		cols = 0;
+
+		linep = vc2_read_ram(dc, vep++);
+		lines = vc2_read_ram(dc, vep++);
+
+		if (lines == 0)
+			break;
+
+		do {
+			/* Iterate over state runs in line sequence table */
+		
+			data = vc2_read_ram(dc, linep++);
+
+			if ((data & 0x0001) == 0)
+				cols += (data >> 7) & 0xfe;
+
+			if ((data & 0x0080) == 0)
+				data = vc2_read_ram(dc, linep++);
+		} while ((data & 0x8000) == 0);
+
+		if (cols != 0) {
+			if (cols > dc->dc_xres)
+				dc->dc_xres = cols;
+
+			dc->dc_yres += lines;
+		}
+	}
+}
+
+static void
+newport_setup_hw(struct newport_devconfig *dc)
+{
+	uint16_t curp,tmp;
+	int i;
+	uint32_t scratch;
+
+	/* Get various revisions */
+	rex3_write(dc, REX3_REG_DCBMODE,
+	    REX3_DCBMODE_DW_1 |
+	    (NEWPORT_DCBADDR_CMAP_0 << REX3_DCBMODE_DCBADDR_SHIFT) |
+	    (CMAP_DCBCRS_REVISION << REX3_DCBMODE_DCBCRS_SHIFT) |
+	    (1 << REX3_DCBMODE_CSWIDTH_SHIFT) |
+	    (1 << REX3_DCBMODE_CSHOLD_SHIFT) |
+	    (1 << REX3_DCBMODE_CSSETUP_SHIFT));
+
+	scratch = vc2_read_ireg(dc, VC2_IREG_CONFIG);
+	dc->dc_vc2rev = (scratch & VC2_IREG_CONFIG_REVISION) >> 5;
+
+	scratch = rex3_read(dc, REX3_REG_DCBDATA0);
+
+	dc->dc_boardrev = (scratch >> 28) & 0x07;
+	dc->dc_cmaprev = scratch & 0x07;
+	dc->dc_xmaprev = xmap9_read(dc, XMAP9_DCBCRS_REVISION) & 0x07;
+	dc->dc_depth = ( (dc->dc_boardrev > 1) && (scratch & 0x80)) ? 8 : 24;
+
+	/* Setup cursor glyph */
+	curp = vc2_read_ireg(dc, VC2_IREG_CURSOR_ENTRY);
+
+	/* Setup VC2 to a known state */
+	tmp = vc2_read_ireg(dc, VC2_IREG_CONTROL) & VC2_CONTROL_INTERLACE;
+	vc2_write_ireg(dc, VC2_IREG_CONTROL, tmp |
+	    VC2_CONTROL_DISPLAY_ENABLE |
+	    VC2_CONTROL_VTIMING_ENABLE |
+	    VC2_CONTROL_DID_ENABLE |
+	    VC2_CONTROL_CURSORFUNC_ENABLE /*|
+	    VC2_CONTROL_CURSOR_ENABLE*/);
+
+	/* Setup XMAP9s */
+	xmap9_write(dc, XMAP9_DCBCRS_CONFIG,
+	    XMAP9_CONFIG_8BIT_SYSTEM | XMAP9_CONFIG_RGBMAP_CI);
+
+	xmap9_write(dc, XMAP9_DCBCRS_CURSOR_CMAP, 0);
+
+	xmap9_write_mode(dc, 0,
+	    XMAP9_MODE_GAMMA_BYPASS |
+	    XMAP9_MODE_PIXSIZE_8BPP);
+	xmap9_write(dc, XMAP9_DCBCRS_MODE_SELECT, 0);
+
+	/* Setup REX3 */
 	rex3_write(dc, REX3_REG_XYWIN, (4096 << 16) | 4096);
 	rex3_write(dc, REX3_REG_TOPSCAN, 0x3ff); /* XXX Why? XXX */
 
 	/* Setup CMAP */
-	for (i=0; i<16; i++)
-		newport_cmap_setrgb(dc, i, newport_defcmap[i*3],
-		    newport_defcmap[i*3 + 1], newport_defcmap[i*3 + 2]);
+	for (i = 0; i < 256; i++)
+		newport_cmap_setrgb(dc, i, rasops_cmap[i * 3],
+		    rasops_cmap[i * 3 + 1], rasops_cmap[i * 3 + 2]);
 }
 
 /**** Attach routines ****/
 static int
-newport_match(struct device *parent, struct cfdata *self, void *aux)
+newport_match(device_t parent, struct cfdata *self, void *aux)
 {
 	struct gio_attach_args *ga = aux;
@@ -622,13 +547,18 @@
 
 	newport_fill_rectangle(dc, 0, 0, dc->dc_xres, dc->dc_yres, 0);
-}
-
-static void
-newport_attach(struct device *parent, struct device *self, void *aux)
+	dc->dc_screen = &newport_screen;
+	
+	dc->dc_mode = WSDISPLAYIO_MODE_EMUL;
+}
+
+static void
+newport_attach(device_t parent, device_t self, void *aux)
 {
 	struct gio_attach_args *ga = aux;
-	struct newport_softc *sc = (void *)self;
+	struct newport_softc *sc = device_private(self);
 	struct wsemuldisplaydev_attach_args wa;
-
+	unsigned long defattr;
+
+	sc->sc_dev = self;
 	if (newport_is_console && ga->ga_addr == newport_console_dc.dc_addr) {
 		wa.console = 1;
@@ -649,10 +579,21 @@
 	    sc->sc_dc->dc_boardrev, sc->sc_dc->dc_cmaprev,
 	    sc->sc_dc->dc_xmaprev, sc->sc_dc->dc_vc2rev, sc->sc_dc->dc_depth);
-
+	vcons_init(&sc->sc_dc->dc_vd, sc->sc_dc, sc->sc_dc->dc_screen,
+	    &newport_accessops);
+	sc->sc_dc->dc_vd.init_screen = newport_init_screen;
+	if (newport_is_console) {
+		newport_console_screen.scr_flags |= VCONS_SCREEN_IS_STATIC;
+		vcons_init_screen(&sc->sc_dc->dc_vd, &newport_console_screen,
+		    1, &defattr);
+		sc->sc_dc->dc_screen->textops =
+		    &newport_console_screen.scr_ri.ri_ops;
+		memcpy(&newport_textops, &newport_console_screen.scr_ri.ri_ops,
+		    sizeof(struct wsdisplay_emulops));
+	}
 	wa.scrdata = &newport_screenlist;
 	wa.accessops = &newport_accessops;
-	wa.accesscookie = sc->sc_dc;
-
-	config_found(&sc->sc_dev, &wa, wsemuldisplaydevprint);
+	wa.accesscookie = &sc->sc_dc->dc_vd;
+
+	config_found(sc->sc_dev, &wa, wsemuldisplaydevprint);
 }
 
@@ -660,6 +601,6 @@
 newport_cnattach(struct gio_attach_args *ga)
 {
+	struct rasops_info *ri = &newport_console_screen.scr_ri;
 	long defattr = NEWPORT_ATTR_ENCODE(WSCOL_WHITE, WSCOL_BLACK);
-	const struct wsscreen_descr *screen;
 
 	if (!newport_match(NULL, NULL, ga)) {
@@ -669,11 +610,25 @@
 	newport_attach_common(&newport_console_dc, ga);
 
-	if (newport_console_dc.dc_xres >= 1280 &&
-	    newport_console_dc.dc_yres >= 1024)
-		screen = &newport_screen_1280x1024;
-	else
-		screen = &newport_screen_1024x768;
-
-	wsdisplay_cnattach(screen, &newport_console_dc, 0, 0, defattr);
+	newport_screen.ncols = newport_console_dc.dc_xres / 8;
+	newport_screen.nrows = newport_console_dc.dc_yres / 16;
+
+	ri->ri_hw = &newport_console_screen;
+	ri->ri_depth = newport_console_dc.dc_depth;
+	ri->ri_width = newport_console_dc.dc_xres;
+	ri->ri_height = newport_console_dc.dc_yres;
+	ri->ri_stride = newport_console_dc.dc_xres; /* XXX */
+	ri->ri_flg = RI_CENTER | RI_FULLCLEAR;
+	ri->ri_ops.copyrows  = newport_copyrows;
+	ri->ri_ops.eraserows = newport_eraserows;
+	ri->ri_ops.copycols  = newport_copycols;
+	ri->ri_ops.erasecols = newport_erasecols;
+	ri->ri_ops.cursor    = newport_cursor_dummy;
+	ri->ri_ops.mapchar   = newport_mapchar;
+	ri->ri_ops.putchar   = newport_putchar;
+	ri->ri_ops.allocattr = newport_allocattr;
+	ri->ri_font = newport_console_dc.dc_fontdata;
+	newport_console_screen.scr_cookie = &newport_console_dc;
+
+	wsdisplay_cnattach(&newport_screen, ri, 0, 0, defattr);
 
 	newport_is_console = 1;
@@ -682,33 +637,69 @@
 }
 
+static void
+newport_init_screen(void *cookie, struct vcons_screen *scr,
+    int existing, long *defattr)
+{
+	struct newport_devconfig *dc = cookie;
+	struct rasops_info *ri = &scr->scr_ri;
+
+	ri->ri_depth = dc->dc_depth;
+	ri->ri_width = dc->dc_xres;
+	ri->ri_height = dc->dc_yres;
+	ri->ri_stride = dc->dc_xres; /* XXX */
+	ri->ri_flg = RI_CENTER;
+
+	/*&ri->ri_bits = (char *)sc->sc_fb.fb_pixels;*/
+
+	rasops_init(ri, dc->dc_yres / 8, dc->dc_xres / 8);
+	ri->ri_caps = WSSCREEN_WSCOLORS;
+
+	rasops_reconfig(ri, dc->dc_yres / ri->ri_font->fontheight,
+		    dc->dc_xres / ri->ri_font->fontwidth);
+
+	ri->ri_hw = scr;
+	ri->ri_ops.copyrows  = newport_copyrows;
+	ri->ri_ops.eraserows = newport_eraserows;
+	ri->ri_ops.copycols  = newport_copycols;
+	ri->ri_ops.erasecols = newport_erasecols;
+	ri->ri_ops.cursor    = newport_cursor;
+	ri->ri_ops.mapchar   = newport_mapchar;
+	ri->ri_ops.putchar   = newport_putchar;
+	ri->ri_ops.allocattr = newport_allocattr;
+}
+
 /**** wsdisplay textops ****/
 static void
+newport_cursor_dummy(void *c, int on, int row, int col)
+{
+}
+
+static void
 newport_cursor(void *c, int on, int row, int col)
 {
-	struct newport_devconfig *dc = (void *)c;
-	uint16_t control;
-	int x_offset;
-
-	control = vc2_read_ireg(dc, VC2_IREG_CONTROL);
-
-	if (!on) {
-		vc2_write_ireg(dc, VC2_IREG_CONTROL,
-		    control & ~VC2_CONTROL_CURSOR_ENABLE);
-	} else {
-		/* Work around bug in some board revisions */
-		if (dc->dc_boardrev < 6)
-			x_offset = 21;
-		else if (dc->dc_vc2rev == 0) 
-			x_offset = 29;
-		else
-			x_offset = 31;
-
-		vc2_write_ireg(dc, VC2_IREG_CURSOR_X,
-		    col * dc->dc_fontdata->fontwidth + x_offset);
-		vc2_write_ireg(dc, VC2_IREG_CURSOR_Y,
-		    row * dc->dc_fontdata->fontheight + 31);
-	
-		vc2_write_ireg(dc, VC2_IREG_CONTROL,
-		    control | VC2_CONTROL_CURSOR_ENABLE);
+	struct rasops_info *ri = c;
+	struct vcons_screen *scr = ri->ri_hw;
+	struct newport_devconfig *dc = scr->scr_cookie;
+	int x, y, wi,he;
+
+	wi = ri->ri_font->fontwidth;
+	he = ri->ri_font->fontheight;
+
+	if (ri->ri_flg & RI_CURSOR) {
+		x = ri->ri_ccol * wi + ri->ri_xorigin;
+		y = ri->ri_crow * he + ri->ri_yorigin;
+		newport_bitblt(dc, x, y, x, y, wi, he, 12);
+		ri->ri_flg &= ~RI_CURSOR;
+	}
+
+	ri->ri_crow = row;
+	ri->ri_ccol = col;
+
+	if (on)
+	{
+		x = ri->ri_ccol * wi + ri->ri_xorigin;
+		y = ri->ri_crow * he + ri->ri_yorigin;
+		newport_bitblt(dc, x, y, x, y, wi, he, 12);
+		ri->ri_flg |= RI_CURSOR;
 	}
 }
@@ -717,5 +708,7 @@
 newport_mapchar(void *c, int ch, unsigned int *cp)
 {
-	struct newport_devconfig *dc = (void *)c;
+	struct rasops_info *ri = c;
+	struct vcons_screen *scr = ri->ri_hw;
+	struct newport_devconfig *dc = scr->scr_cookie;
 
 	if (dc->dc_fontdata->encoding != WSDISPLAY_FONTENC_ISO) {
@@ -741,12 +734,14 @@
 newport_putchar(void *c, int row, int col, u_int ch, long attr)
 {
-	struct newport_devconfig *dc = (void *)c;
-	struct wsdisplay_font *font = dc->dc_fontdata;
+	struct rasops_info *ri = c;
+	struct vcons_screen *scr = ri->ri_hw;
+	struct newport_devconfig *dc = scr->scr_cookie;
+	struct wsdisplay_font *font = ri->ri_font;
 	uint8_t *bitmap = (u_int8_t *)font->data + (ch - font->firstchar) * 
 	    font->fontheight * font->stride;
 	uint32_t pattern;
 	int i;
-	int x = col * font->fontwidth;
-	int y = row * font->fontheight;
+	int x = col * font->fontwidth + ri->ri_xorigin;
+	int y = row * font->fontheight + ri->ri_yorigin;
 
 	rex3_wait_gfifo(dc);
@@ -756,4 +751,14 @@
 	    REX3_DRAWMODE0_ENZPATTERN | REX3_DRAWMODE0_ZPOPAQUE);
 
+	rex3_write(dc, REX3_REG_DRAWMODE1,
+	    REX3_DRAWMODE1_PLANES_CI |
+	    REX3_DRAWMODE1_DD_DD8 |
+	    REX3_DRAWMODE1_RWPACKED |
+	    REX3_DRAWMODE1_HD_HD8 |
+	    REX3_DRAWMODE1_COMPARE_LT |
+	    REX3_DRAWMODE1_COMPARE_EQ |
+	    REX3_DRAWMODE1_COMPARE_GT |
+	    REX3_DRAWMODE1_LO_SRC);
+
 	rex3_write(dc, REX3_REG_XYSTARTI, (x << REX3_XYSTARTI_XSHIFT) | y);
 	rex3_write(dc, REX3_REG_XYENDI,
@@ -765,5 +770,5 @@
 	rex3_write(dc, REX3_REG_WRMASK, 0xffffffff);
 
-	for (i=0; i<font->fontheight; i++) {
+	for (i = 0; i < font->fontheight; i++) {
 		/* XXX Works only with font->fontwidth == 8 XXX */
 		pattern = *bitmap << 24;
@@ -778,14 +783,15 @@
 newport_copycols(void *c, int row, int srccol, int dstcol, int ncols)
 {
-	struct newport_devconfig *dc = (void *)c;
-	struct wsdisplay_font *font = dc->dc_fontdata;
-
-	newport_copy_rectangle(dc,
-	    srccol * font->fontwidth,			/* x1 */
-	    row * font->fontheight,			/* y1 */
-	    (srccol + ncols + 1) * font->fontwidth - 1,	/* x2 */
-	    (row + 1) * font->fontheight - 1,		/* y2 */
-	    dstcol * font->fontheight,			/* dx */
-	    row * font->fontheight);			/* dy */
+	struct rasops_info *ri = c;
+	struct vcons_screen *scr = ri->ri_hw;
+	struct newport_devconfig *dc = scr->scr_cookie;
+	int32_t xs, xd, y, width, height;
+
+	xs = ri->ri_xorigin + ri->ri_font->fontwidth * srccol;
+	xd = ri->ri_xorigin + ri->ri_font->fontwidth * dstcol;
+	y = ri->ri_yorigin + ri->ri_font->fontheight * row;
+	width = ri->ri_font->fontwidth * ncols;
+	height = ri->ri_font->fontheight;
+	newport_bitblt(dc, xs, y, xd, y, width, height, 3);
 }
 
@@ -794,5 +800,7 @@
     long attr)
 {
-	struct newport_devconfig *dc = (void *)c;
+	struct rasops_info *ri = c;
+	struct vcons_screen *scr = ri->ri_hw;
+	struct newport_devconfig *dc = scr->scr_cookie;
 	struct wsdisplay_font *font = dc->dc_fontdata;
 
@@ -800,5 +808,5 @@
 	    startcol * font->fontwidth,				/* x1 */
 	    row * font->fontheight,				/* y1 */
-	    (startcol + ncols + 1) * font->fontwidth - 1,	/* x2 */
+	    (startcol + ncols) * font->fontwidth - 1,		/* x2 */
 	    (row + 1) * font->fontheight - 1,			/* y2 */
 	    NEWPORT_ATTR_BG(attr));
@@ -808,14 +816,16 @@
 newport_copyrows(void *c, int srcrow, int dstrow, int nrows)
 {
-	struct newport_devconfig *dc = (void *)c;
-	struct wsdisplay_font *font = dc->dc_fontdata;
-
-	newport_copy_rectangle(dc,
-	    0,							/* x1 */
-	    srcrow * font->fontheight,				/* y1 */
-	    dc->dc_xres,					/* x2 */
-	    (srcrow + nrows + 1) * font->fontheight - 1,	/* y2 */
-	    0,							/* dx */
-	    dstrow * font->fontheight);				/* dy */
+	struct rasops_info *ri = c;
+	struct vcons_screen *scr = ri->ri_hw;
+	struct newport_devconfig *dc = scr->scr_cookie;
+	int32_t x, ys, yd, width, height;
+
+	x = ri->ri_xorigin;
+	ys = ri->ri_yorigin + ri->ri_font->fontheight * srcrow;
+	yd = ri->ri_yorigin + ri->ri_font->fontheight * dstrow;
+	width = ri->ri_emuwidth;
+	height = ri->ri_font->fontheight * nrows;
+
+	newport_bitblt(dc, x, ys, x, yd, width, height, 3);
 }
 
@@ -823,5 +833,7 @@
 newport_eraserows(void *c, int startrow, int nrows, long attr)
 {
-	struct newport_devconfig *dc = (void *)c;
+	struct rasops_info *ri = c;
+	struct vcons_screen *scr = ri->ri_hw;
+	struct newport_devconfig *dc = scr->scr_cookie;
 	struct wsdisplay_font *font = dc->dc_fontdata;
 
@@ -830,5 +842,5 @@
 	    startrow * font->fontheight,			/* y1 */
 	    dc->dc_xres,					/* x2 */
-	    (startrow + nrows + 1) * font->fontheight - 1,	/* y2 */
+	    (startrow + nrows) * font->fontheight - 1,		/* y2 */
 	    NEWPORT_ATTR_BG(attr));
 }
@@ -862,8 +874,15 @@
 
 static int
-newport_ioctl(void *c, void *vs, u_long cmd, void *data, int flag,
+newport_ioctl(void *v, void *vs, u_long cmd, void *data, int flag,
 	struct lwp *l)
 {
-	struct newport_softc *sc = c;
+	struct vcons_data *vd;
+	struct newport_devconfig *dc;
+	struct vcons_screen *ms;
+	int nmode;
+
+	vd = (struct vcons_data *)v;
+	dc = (struct newport_devconfig *)vd->cookie;
+	ms = (struct vcons_screen *)vd->active;
 
 #define FBINFO (*(struct wsdisplay_fbinfo*)data)
@@ -871,7 +890,7 @@
 	switch (cmd) {
 	case WSDISPLAYIO_GINFO:
-		FBINFO.width  = sc->sc_dc->dc_xres;
-		FBINFO.height = sc->sc_dc->dc_yres;
-		FBINFO.depth  = sc->sc_dc->dc_depth;
+		FBINFO.width  = dc->dc_xres;
+		FBINFO.height = dc->dc_yres;
+		FBINFO.depth  = dc->dc_depth;
 		FBINFO.cmsize = 1 << FBINFO.depth;
 		return 0;
@@ -879,4 +898,15 @@
 		*(u_int *)data = WSDISPLAY_TYPE_NEWPORT;
 		return 0;
+	case WSDISPLAYIO_SMODE:
+		nmode = *(int *)data;
+		if (nmode != dc->dc_mode) {
+			dc->dc_mode = nmode;
+			if (nmode == WSDISPLAYIO_MODE_EMUL) {
+				rex3_wait_gfifo(dc);
+				newport_setup_hw(dc);
+				vcons_redraw_screen(vd->active);
+			}
+		}
+		return 0;
 	}
 	return EPASSTHROUGH;
@@ -884,7 +914,11 @@
 
 static paddr_t
-newport_mmap(void *c, void *vs, off_t offset, int prot)
-{
-	struct newport_devconfig *dc = c;
+newport_mmap(void *v, void *vs, off_t offset, int prot)
+{
+	struct vcons_data *vd;
+	struct newport_devconfig *dc;
+
+	vd = (struct vcons_data *)v;
+	dc = (struct newport_devconfig *)vd->cookie;
 
 	if ( offset >= 0xfffff)
@@ -893,24 +927,2 @@
 	return mips_btop(dc->dc_addr + offset);
 }
-
-static int
-newport_alloc_screen(void *c, const struct wsscreen_descr *type, void **cookiep,
-    int *cursxp, int *cursyp, long *attrp)
-{
-	/* This won't get called for console screen and we don't support
-	 * virtual screens */
-
-	return ENOMEM;
-}
-
-static void
-newport_free_screen(void *c, void *cookie)
-{
-	panic("newport_free_screen");
-}
-static int
-newport_show_screen(void *c, void *cookie, int waitok,
-    void (*cb)(void *, int, int), void *cbarg)
-{
-	return 0;
-}
Index: /trunk/src/sys/arch/sgimips/gio/newportreg.h
===================================================================
--- /trunk/src/sys/arch/sgimips/gio/newportreg.h	(revision 151)
+++ /trunk/src/sys/arch/sgimips/gio/newportreg.h	(revision 152)
@@ -1,4 +1,4 @@
 
-/*	$NetBSD: newportreg.h,v 1.3 2005/12/11 12:18:53 christos Exp $	*/
+/*	$NetBSD: newportreg.h,v 1.3.96.1 2010/12/29 07:19:28 matt Exp $	*/
 
 /*
@@ -129,5 +129,11 @@
 #define  REX3_DRAWMODE0_LENGTH32	0x00008000
 #define  REX3_DRAWMODE0_ZPOPAQUE	0x00010000
-
+#define  REX3_DRAWMODE0_LSOPAQUE	0x00020000
+#define  REX3_DRAWMODE0_SHADE		0x00040000
+#define  REX3_DRAWMODE0_LRONLY		0x00080000
+#define  REX3_DRAWMODE0_XYOFFSET	0x00100000
+#define  REX3_DRAWMODE0_CICLAMP		0x00200000
+#define  REX3_DRAWMODE0_ENDPTFILTER	0x00400000
+#define  REX3_DRAWMODE0_YSTRIDE		0x00800000
 #define REX3_REG_LSMODE			0x0008
 
Index: /trunk/src/sys/arch/sgimips/hpc/files.hpc
===================================================================
--- /trunk/src/sys/arch/sgimips/hpc/files.hpc	(revision 151)
+++ /trunk/src/sys/arch/sgimips/hpc/files.hpc	(revision 152)
@@ -1,3 +1,3 @@
-# $NetBSD: files.hpc,v 1.12 2006/08/27 10:05:23 bjh21 Exp $
+# $NetBSD: files.hpc,v 1.12.78.1 2010/12/29 07:19:28 matt Exp $
 
 device	sq: arp, ether, ifnet
@@ -34,2 +34,5 @@
 file	arch/sgimips/hpc/pi1ppc.c	pi1ppc
 
+device	panel : sysmon_power, sysmon_taskq
+attach	panel at hpc
+file	arch/sgimips/hpc/panel.c	panel
Index: /trunk/src/sys/arch/sgimips/hpc/haltwo.c
===================================================================
--- /trunk/src/sys/arch/sgimips/hpc/haltwo.c	(revision 151)
+++ /trunk/src/sys/arch/sgimips/hpc/haltwo.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: haltwo.c,v 1.15 2008/08/24 13:03:39 tsutsui Exp $ */
+/* $NetBSD: haltwo.c,v 1.15.12.1 2010/12/29 07:19:28 matt Exp $ */
 
 /*
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: haltwo.c,v 1.15 2008/08/24 13:03:39 tsutsui Exp $");
+__KERNEL_RCSID(0, "$NetBSD: haltwo.c,v 1.15.12.1 2010/12/29 07:19:28 matt Exp $");
 
 #include <sys/param.h>
@@ -610,4 +610,5 @@
 		strcpy(dev->label.name, AudioNmaster);
 		dev->un.v.num_channels = 2;
+		dev->un.v.delta = 16;
 		strcpy(dev->un.v.units.name, AudioNvolume);
 		break;
Index: /trunk/src/sys/arch/sgimips/hpc/hpc.c
===================================================================
--- /trunk/src/sys/arch/sgimips/hpc/hpc.c	(revision 151)
+++ /trunk/src/sys/arch/sgimips/hpc/hpc.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: hpc.c,v 1.60.38.1 2009/08/26 03:46:40 matt Exp $	*/
+/*	$NetBSD: hpc.c,v 1.60.38.2 2010/12/29 07:19:28 matt Exp $	*/
 
 /*
@@ -36,5 +36,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: hpc.c,v 1.60.38.1 2009/08/26 03:46:40 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: hpc.c,v 1.60.38.2 2010/12/29 07:19:28 matt Exp $");
 
 #include <sys/param.h>
@@ -214,4 +214,10 @@
 	  -1,
 	  HPCDEV_IP22 | HPCDEV_IP24 },
+
+	{ "panel",	/* Indy front panel */
+	  HPC_BASE_ADDRESS_0,
+	  HPC3_PBUS_CH6_DEVREGS + IOC_PANEL, 0,
+	  9,
+	  HPCDEV_IP24 },
 
 	{ NULL,
